interface IEuclid#(type t);
    method Action start(t a, t b);
    method t result();
endinterface

module mkEuclidFast(IEuclid#(Int#(32)));
    Reg#(Int#(32)) x <- mkRegU;
    Reg#(Int#(32)) y <- mkReg(0);
    rule trocar_subtrair((x > y) && (y != 0));
        x <= y; y <= x - y;
    endrule
    rule subtrair((x <= y) && (y != 0));
        y <= y - x;
    endrule
    method Action start(Int#(32) a, Int#(32) b) if(y == 0);
        x <= a; y <= (a==0) ? 0 : b;
    endmethod
    method Int#(32) result() if(y == 0);
        return x;
    endmethod
endmodule
